import java.util.Vector;

public class ArrayContas {
	private Conta[]  contas;
	private int indice;
	private final static int tamCache = 100;

	public ArrayContas() {
	  indice = 0;
	  contas = new Conta[tamCache];
	}

	public void atualizar(Conta c){
	  int i = procurarIndice(c.getNumero());
	  if (i != -1) {
	    contas[i] = c;
	  } else {
	    throw new RuntimeException("Conta nao encontrada");
	  }
	}
	public boolean existe(String num) {
	  boolean resp = false;

	  int i = this.procurarIndice(num);
	  if(i != -1){
		resp = true;
	  }

	  return resp;
	}
	public void inserir(Conta c){
	    contas[indice] = c;
	    indice = indice + 1;
	}
	public Conta procurar(String num){
	  Conta c = null;
	  if (existe(num)) {
  	    int i = this.procurarIndice(num);
	    c = contas[i];
	  } else {
	    throw new RuntimeException("Conta nao encontrada");
	  }

	  return c;
	}

	private int procurarIndice(String num) {
	  int     i = 0;
	  int     ind = -1;
	  boolean achou = false;

	  while ((i < indice) &&!achou) {
	    if ((contas[i].getNumero()).equals(num)) {
		ind = i;
		achou = true;
	    }
	    i = i + 1;
	  }
	  return ind;
	}

	public void remover(String num){
	  if (existe(num)) {
  	    int i = this.procurarIndice(num);
	    contas[i] = contas[indice - 1];
	    contas[indice - 1] = null;
	    indice = indice - 1;
	  } else {
	    throw new RuntimeException("Conta nao encontrada");
	  }
	}

        /**
         * Procura todas as contas associadas a um cliente
         * e devolde numa colecao iteravel.
         */
        public ColecaoContasIteravel procurarContas(String cpfCliente){
          ColecaoContasIteravel retorno = null;

          Vector colecao = new Vector();
	  int     i = 0;
	  boolean achou = false;

	  while ((i < indice) &&!achou) {
	    if ( contas[i].getCliente().getCpf().equals(cpfCliente)) {
		achou = true;
                colecao.addElement(contas[i]);
	    }
	    i = i + 1;
	  }

          retorno = new ColecaoContasIteravel(colecao.iterator());

          return retorno;

        }
}
